#!/usr/bin/perl

use strict;
use TParse;
use FilePaths;


main();
sub main {
    my %paths;

    while(my $line = <STDIN>) {
	chomp($line);
	my @args = TParse::parseLine($line);
	my $syscall = TParse::arg(\@args, 'syscall');
	my @argNames = TParse::getArgNames($syscall);

	foreach my $argName (@argNames) {
	    if($argName =~ m/path/i) {
		my $path1 = TParse::arg(\@args, $argName);
		my $path2 = FilePaths::simplifyPath($path1);
		$paths{$path2} = 1;
	    }
	}
    }

    foreach my $path (sort (keys(%paths))) {
	print "$path\n";
    }
}



