package TParse;
use strict;
#This hash is useful for programs that parse the traces generated by this DTrace script:

my %argIndices = (
	'open' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'oflag' => 5, 'flags' => 6, 'type' => 7, 'inode' => 8, 'file_table' => 9, 'stack' => 10, 'ret' => 11, },
	'shm_open' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'name' => 4, 'oflag' => 5, 'ret' => 6, },
	'close' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'dup' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'kqueue' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'ret' => 4, },
	'socket' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'domain' => 4, 'type' => 5, 'protocol' => 6, 'ret' => 7, },
	'socketpair' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'domain' => 4, 'type' => 5, 'protocol' => 6, 'fd1' => 7, 'fd2' => 8, 'ret' => 9, },
	'read' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'nbyte' => 5, 'offset' => 6, 'stack' => 7, 'ret' => 8, },
	'write' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'nbyte' => 5, 'offset' => 6, 'stack' => 7, 'ret' => 8, },
	'pread' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'nbyte' => 5, 'offset' => 6, 'stack' => 7, 'ret' => 8, },
	'pwrite' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'nbyte' => 5, 'offset' => 6, 'stack' => 7, 'ret' => 8, },
	'aio_read' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'aiocbp' => 4, 'fildes' => 5, 'offset' => 6, 'size' => 7, 'retsize' => 8, 'stack' => 9, 'ret' => 10, },
	'aio_error' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'aiocbp' => 4, 'ret' => 5, },
	'aio_return' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'aiocbp' => 4, 'ret' => 5, },
	'aio_suspend' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'nent' => 4, 'ret' => 5, },
	'lseek' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'offset' => 5, 'whence' => 6, 'ret' => 7, },
	'fsync' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'stack' => 5, 'ret' => 6, },
	'fcntl' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'cmd' => 5, 'arg' => 6, 'cmd_name' => 7, 'stack' => 8, 'ret' => 9, },
	'ftruncate' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'length' => 5, 'stack' => 6, 'ret' => 7, },
	'link' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path1' => 4, 'path2' => 5, 'ret' => 6, },
	'symlink' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path1' => 4, 'path2' => 5, 'ret' => 6, },
	'rmdir' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'unlink' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'readlink' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'bufsize' => 5, 'target' => 6, 'ret' => 7, },
	'rename' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'old_path' => 4, 'new_path' => 5, 'inode' => 6, 'type' => 7, 'from_dir_inode' => 8, 'to_dir_inode' => 9, 'stack' => 10, 'ret' => 11, },
	'exchangedata' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path1' => 4, 'path2' => 5, 'inode1' => 6, 'inode2' => 7, 'ret' => 8, },
	'mkdir' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'mode' => 5, 'ret' => 6, },
	'flock' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fd' => 4, 'operation' => 5, 'stack' => 6, 'ret' => 7, },
	'mmap' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'addr' => 4, 'len' => 5, 'prot' => 6, 'flags' => 7, 'fd' => 8, 'offset' => 9, 'protstr' => 10, 'flagsstr' => 11, 'ret' => 12, },
	'futimes' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'utimes' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'statfs' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'statfs64' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'fstatfs64' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'fstat' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'lstat' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'stat' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'fstat64' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'lstat64' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'stat64' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'setattrlist' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'getattrlist' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'getxattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'fgetxattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fd' => 4, 'ret' => 5, },
	'listxattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'flistxattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fd' => 4, 'ret' => 5, },
	'access' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'amode' => 5, 'ret' => 6, },
	'chown' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'owner' => 5, 'group' => 6, 'ret' => 7, },
	'chmod' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'mode' => 5, 'ret' => 6, },
	'fsetxattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'name' => 5, 'ret' => 6, },
	'fsgetpath' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fsid' => 4, 'ret' => 5, },
	'getdirentries64' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'getdirentriesattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'getfsstat64' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'ret' => 4, },
	'getdtablesize' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'ret' => 4, },
	'chdir' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5, },
	'fchdir' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'ret' => 5, },
	'kill' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'pid' => 4, 'sig' => 5, 'ret' => 6, },
	'fchflags' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fd' => 4, 'flags' => 5, 'ret' => 6, },
	'fchmod' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'mode' => 5, 'ret' => 6, },
	'fchown' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fildes' => 4, 'owner' => 5, 'group' => 6, 'ret' => 7, },
	'removexattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'name' => 5, 'ret' => 6, },
	'fremovexattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'fd' => 4, 'name' => 5, 'ret' => 6, },
	'setxattr' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'name' => 5, 'ret' => 6, },
	'controller' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'msg' => 4 },
	'resolver' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'vol' => 4, 'resolved' => 5, 'original_path' => 6, 'comments' => 7},
	'all_calls' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'name' => 4 },
	'setter' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'variable' =>  4, 'value' => 5 },
	'build_path' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'inode' => 4, 'path' => 5 },
	'namei' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'resolved' => 5 },
	'vn_create' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'inode' => 4 },
	'hfs_vnop_pagein' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'offset' => 4, 'size' => 5, 'inode' => 6, 'name' => 7, 'actual_size' => 8, 'ret' => 9 },
	'vnode_pagein' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'offset' => 4, 'size' => 5, 'inode' => 6, 'name' => 7, 'actual_size' => 8, 'ret' => 9 },
	'syscall_map' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'map' => 4},
	'posix_spawn' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5},
	'execve' => {'time' => 0, 'tid' => 1, 'probe_type' => 2, 'syscall' => 3, 'path' => 4, 'ret' => 5}, 
);
my %ignoreCalls = (
'bsdthread_create' => 1,
'ptrace' => 1,
'workq_open' => 1,
'workq_kernreturn' => 1,
'wait4' => 1,
'thread_selfid' => 1,
'sigprocmask' => 1,
'sigaltstack' => 1,
'sigaction' => 1,
'shared_region_check_np' => 1,
'setsockopt' => 1,
'sendto' => 1,
'sendmsg' => 1,
'select' => 1,
'recvfrom' => 1,
'proc_info' => 1,
'poll' => 1,
'munmap' => 1,
'mprotect' => 1,
'madvise' => 1,
'kevent' => 1,
'kdebug_trace' => 1,
'issetugid' => 1,
'ioctl' => 1,
'getuid' => 1,
'getsockname' => 1,
'getsockopt' => 1,
'getrusage' => 1,
'getrlimit' => 1,
'setrlimit' => 1,
'getpid' => 1,
'getpeername' => 1,
'getlogin' => 1,
'gethostuuid' => 1,
'getgroups' => 1,
'getgid' => 1,
'geteuid' => 1,
'getegid' => 1,
'connect' => 1,
'bsdthread_register' => 1,
'audit_session_self' => 1,
'__disable_threadsignal' => 1,
'__pthread_markcancel' => 1,
'__semwait_signal' => 1,
'__sysctl' => 1,
'__mac_syscall' => 1,
'csops' => 1,
'delete' => 1,
'msync' => 1,
'posix_spawn' => 1,
'execve' => 1,
'bsdthread_terminate' => 1,
'exit' => 1,
);

    sub parseLine {
        die if $#_ != 0;

        my ($line) = @_;

        my @curArgs = split('\]; \[', $line);

        $curArgs[0] =~ s/^\[//;
        $curArgs[-1] =~ s/\];\s?//;
        $curArgs[3] =~ s/\_nocancel//;
        $curArgs[3] =~ s/\_extended//;

        my $curCall = $curArgs[3];
    
        #we don't handle this syscall yet
        if(! defined($argIndices{$curCall})) {
            die "'$curCall' not in the hash!  Line is: '$line'\n";
        }

        return @curArgs;
    }


    sub parseTuple {
        die if $#_ != 0;
        my ($line) = @_;

        my @elements = split('\]; \[', $line);
        $elements[0] =~ s/^\[//;
        $elements[-1] =~ s/\];\s?//;
        return @elements;
    }


    sub argExists {
        die if $#_ != 1;
        my ($curArgsRef, $argName) = @_;
	my $curCall = $curArgsRef->[3];
        return (defined($argIndices{$curCall}{$argName}));
    }
    
    sub arg {
        die if $#_ != 1;
        my ($curArgsRef, $argName) = @_;
	my $curCall = $curArgsRef->[3];
    
        if (! defined($argIndices{$curCall}{$argName})) {
            die "'$argName' isn't an arg for $curCall\n";
        }
    
        if ($argIndices{$curCall}{$argName} > (scalar(@$curArgsRef)-1)) {
            die ($argIndices{$curCall}{$argName} . ">" . (scalar(@$curArgsRef)-1) . " for $curCall\n");
        }
    
        return $curArgsRef->[$argIndices{$curCall}{$argName}];
    }

    sub setArg {
        die if $#_ != 2;
        my ($curArgsRef, $argName, $val) = @_;
	my $curCall = $curArgsRef->[3];
    
        if (! defined($argIndices{$curCall}{$argName})) {
            die "'$argName' isn't an arg for $curCall\n";
        }
    
        if ($argIndices{$curCall}{$argName} > (scalar(@$curArgsRef)-1)) {
            die ($argIndices{$curCall}{$argName} . ">" . (scalar(@$curArgsRef)-1) . " for $curCall\n");
        }
    
        $curArgsRef->[$argIndices{$curCall}{$argName}] = $val;
    }

    sub argIndex {
        die if $#_ != 1;
        my ($callName, $argName) = @_;
    
        if (! defined($argIndices{$callName}{$argName})) {
            die "'$argName' isn't an arg for $callName\n";
        }

	return $argIndices{$callName}{$argName};
    }

    sub args2str {
        die if $#_ != 0;
        my ($curArgsRef) = @_;

	return ("[" . join("]; [", @$curArgsRef) . "]; ");
    }

    sub getArgNames {
        die if $#_ != 0;
        my ($syscall) = @_;
        return keys %{$argIndices{$syscall}};
    }

    sub getCallNames {
        die if $#_ != -1;
        return keys %argIndices;
    }


    sub getIgnoreCallNames {
        die if $#_ != -1;
        return keys %ignoreCalls;
    }



    #list of most of the things that create FDs
    #(we also have to cover fcntl sometimes)
    my %fdCreationHash = (
        "open,ret" => 1,
        "shm_open,ret" => 1,
        "dup,ret" => 1,
        "dup2,fildes2" => 1,
        "pipe,read_fd" => 1,
        "pipe,write_fd" => 1,
        "socket,ret" => 1,
        "socketpair,fd1" => 1,
        "socketpair,fd2" => 1,
        "kqueue,ret" => 1,
    );
    
    sub isFD {
        my ($curArgsRef, $argName) = @_;
        if($argName =~ /^fd/ or $argName =~ /fd$/ or $argName =~ /fildes/) {
        	return 1;
        }
    
        if(isCreatedFD($curArgsRef, $argName)) {
    	return 1;
        }
    
        return 0;
    }
    
    sub isCreatedFD {
        die if $#_ != 1;
        my ($curArgsRef, $argName) = @_;
        my $syscall = TParse::arg($curArgsRef, "syscall");
    
        if(exists $fdCreationHash{"$syscall,$argName"}) {
    	return 1;
        }
    
        #cmd=0 is F_DUPFD
        if($syscall eq "fcntl" and $argName eq "ret" and TParse::arg($curArgsRef, "cmd") == 0) {
        	return 1;
        }
    
        return 0;
    }

    